from urllib.parse import urlparse
from antavo.escherauth import Escher
import datetime
import requests
# Debuging
import logging
import http.client as http_client
http_client.HTTPConnection.debuglevel = 1

## configuration
# Http request
http_method = 'POST'
web_request = ''
parsed_url = urlparse(web_request)
host = parsed_url.netloc
url = (parsed_url.path + '?' + parsed_url.query).rstrip('?')
url_split = url.rfind("/")
uri = url[:url_split]
body = url[url_split+1:]
endpoint = parsed_url.scheme + "://" + host + uri

# Keys
access_key = ""
secret_key = ""

credential_scope = ''

# specific date
# date = datetime.datetime(2017, 3, 7, 8, 21, 2)
date = datetime.datetime.utcnow()

# Antavo specific
algo_prefix = 'ANTAVO'
vendor_key = 'antavo'
hash_algo = 'SHA256'
auth_header_name = 'Authorization'
date_header_name = 'Date'

escher = Escher(credential_scope,
                {
                    'algo_prefix': algo_prefix,
                    'vendor_key': vendor_key,
                    'hash_algo': 'SHA256',
                    'auth_header_name': 'Authorization',
                    'date_header_name': 'Date',
                    'current_time': date
                })

request = {
    'method': http_method,
    'host':  host,
    'uri': uri,
    'body': body,
    'query': parsed_url.query,
    'headers': [
        (
            
            'Date', date.strftime('%Y%m%dT%H%M%SZ')),
        ('Host', host),
    ],
}

request = escher.sign(request, {'api_key': access_key,
                                'api_secret': secret_key})

#convert headers into a dictionary from list of tuples
headers = {}
for header in request['headers']:
    headers[header[0]] = "".join(header[1:])
headers['Content-Type'] = 'application/x-www-form-urlencoded'

#Request submission

print('\nBEGIN REQUEST++++++++++++++++++++++++++++++++++++')
print('Request URL = ' + endpoint)


rest_method = getattr(requests, http_method.lower())
r = rest_method(endpoint,data=body, headers=headers)

print('\nRESPONSE++++++++++++++++++++++++++++++++++++')
print('Response code: %d\n' % r.status_code)
print(r.text)
